
#include "TROOT.h"
#include "TSystem.h"
#include "TFile.h"
#include "TTree.h"
#include "TCanvas.h"
#include "TH1.h"
#include "TH1D.h"
#include "TGraph2D.h"
#include "TGraph2DErrors.h"
#include "Buttons.h"
#include "TVirtualFitter.h"
#include "TPolyLine3D.h"
#include "TMath.h"
#include "Math/Vector3D.h"

#include <iostream>
#include <string>
#include <deque>
#include <cmath>

#include "CDataHime.hh"
#include "CDataHimeSim.hh"
#include "CKinema.hh"
#include "CParticle.hh"

//#define VISUALIZE 1

void Analysis(std::string filename, std::string method);
void SimToExp(CDataHimeSim* data, CDataHime* expdata);
void Track(CDataHime* expdata);
void Simple(CDataHime* expdata);
void Niren(CDataHime* expdata);

void EventLoop();
void line(double t, double *p, double &x, double &y, double &z);
double distance2(double x,double y,double z, double ex, double ey, double ez, double *p);
void SumDistance2(int &, double *, double & sum, double * par, int );
double line3Dfit(TGraph2DErrors* gr, double parFit[4]);
void DrawLine(double parFit[4], Color_t color);

Double_t MeVtoMeVee(Double_t Tin, Double_t Tout, std::string name);

static const Double_t light_v = 29.979;

static const Double_t thr = 3.5;
//static const Double_t treso = 0.13;
static const Double_t treso = 0.184;//全体に対してsqrt(2)倍じゃなきゃだめ！！
//static const Double_t treso = 0.20;
static const Double_t attlength = 100.;
static const Double_t length = 100.;
static const Double_t efflength = 40.;
static const Double_t width = 4.;
static const Double_t depth = 2.;
//static const Double_t zdepth = 800.;
static const Double_t zdepth = 900.;
static const Double_t vl = 15.;
static const Double_t aminmin = 20.;
//static const Double_t aminmin = 100.;
static const Double_t ein = 230;
//static const Double_t ein = 250;
static const Double_t sn = 15;
static const Double_t shift = efflength/2.;

//static const std::deque<CDataHime::OneData>::size_type multihit = 2;
static const std::deque<CDataHime::OneData>::size_type multihit = 3;
//static const std::deque<CDataHime::OneData>::size_type multihit = 4;
//static const std::deque<CDataHime::OneData>::size_type multihit = 5;
