#ifndef ANALYSISSPECTRUM_HH
#define ANALYSISSPECTRUM_HH

// void AnalysisSpectrum3(std::string filename,
// 		       std::string facility, std::string detector,
// 		       std::string fragment, std::string target,
// 		       std::string beam, std::string method, Long64_t nentries = -1);
 
class Analysis
{
public:
  Analysis(){;}
  ~Analysis(){;}
  
  void AnalysisSpectrum(std::string filename,
			std::string facility, std::string detector,
			std::string fragment, std::string target,
			std::string beam, std::string method, Long64_t nentries);

  int ReadParamaters(std::string facility, std::string detector,
		     std::string fragment, std::string target);

  //calculate simlation data to experiment data
  void SimToExp(CDataHimeSim* simdata, CDataHime* dataexp, std::string method);

  //analysis method for experiment data
  void Track(CDataHime* dataexp);
  void Simple(CDataHime* dataexp);
  void Niren(CDataHime* dataexp);//not optimized

  int GetFirstProtonInformation(CDataHimeSim* data, CParticle& proton);
  double GetTotalEnergyLoss(CDataHime* data);
  void FoldChargedParticle(TVector3 momentum, CParticle& particle,
			   TVector3 dpoverp, double dele, double estrag, double multi_theta);

  //paramaters
  Double_t dpxoverp, dpyoverp, dpzoverp, dele, estrag, multi_theta;
  Int_t thrmethod;
  Double_t thr, treso, attlength, vl;
  Int_t rotation;
  Double_t length, vlength, width, depth, gap, zdepth, zdepth_back, shift;
  Int_t multihit;
  Double_t aminmin, ein, sp;
  Double_t step;
};

#include "Analysis_sub3.C"

#endif
