
#include <iostream>

#include "TROOT.h"
#include "TStyle.h"
#include "TCanvas.h"
#include "TF1.h"

#include "CMapFunction1D.hh"
#include "CFold.hh"

Double_t mysum(Double_t* x, Double_t* par);
Double_t fmapfs_m(Double_t* x, Double_t* par);
Double_t fmapfp_m(Double_t* x, Double_t* par);

TF1* fmapfs;
TF1* fmapfp;

TF1* ffmapfs;
TF1* ffmapfp;

void fold2()
{
  TCanvas* canvas = new TCanvas("canvas","",200,10,900,900);
  canvas->SetFillColor(0);

  gStyle->SetOptFit(0);
  gStyle->SetOptStat(0);

  CMapFunction1D* mapfs = new CMapFunction1D;
  CMapFunction1D* mapfp = new CMapFunction1D;
  mapfs->SetFile("./macros/10Li/sigl.11Li-n_s12");
  mapfp->SetFile("./macros/10Li/sigl.11Li-n_p12");

  fmapfs = new TF1("fmapfs",
		   mapfs,
		   static_cast<Double_t (CMapFunction1D::*)(Double_t*, Double_t*)>
		   (&CMapFunction1D::MapFunction),
		   -150, 150, 1);
  fmapfp = new TF1("fmapfp",
		   mapfp,
		   static_cast<Double_t (CMapFunction1D::*)(Double_t*, Double_t*)>
		   (&CMapFunction1D::MapFunction),
		   -150, 150, 1);

  TF1* fmapfsm = new TF1("fmapfs_m", fmapfs_m, -150, 150);
  TF1* fmapfpm = new TF1("fmapfp_m", fmapfp_m, -150, 150);
  
  CFold* folds = new CFold(fmapfsm);
  folds->SetSigma(20);
  folds->SetStep(0.5);
  CFold* foldp = new CFold(fmapfpm);
  foldp->SetSigma(20);
  foldp->SetStep(0.5);

  ffmapfs = folds->GetFoldedFunction();
  ffmapfp = foldp->GetFoldedFunction();

  TF1* ffsum = new TF1("ffsum", mysum, -150, 150);

  ffsum->SetLineStyle(1);
  ffsum->Draw();

  if(0){
    fmapfs->SetLineStyle(2);
    fmapfp->SetLineStyle(3);  
    fmapfs->Draw("same");
    fmapfp->Draw("same");
  }else{
    ffmapfs->SetLineStyle(2);
    ffmapfp->SetLineStyle(3);  
    ffmapfs->Draw("same");
    ffmapfp->Draw("same");
  }
}
  
Double_t mysum(Double_t* x, Double_t* par)
{
  return ffmapfs->Eval(x[0]) + ffmapfp->Eval(x[0]);
}

Double_t fmapfs_m(Double_t* x, Double_t* par)
{
  return fmapfs->Eval(x[0])*(100./(138+78))/0.0105;
}

Double_t fmapfp_m(Double_t* x, Double_t* par)
{
  return fmapfp->Eval(x[0])*(100./(138+78))/0.0105;
}
