
#include <iostream>
#include <cmath>

//あるベクトルで定義される角度(theta,phi)の回転を計算するクラス。
//もし(0,0,1)ならセットしたベクトルに沿って回転させる。
class COmega
{
public:
  COmega(double px, double py, double pz)
    : m_px(px), m_py(py), m_pz(pz),
      m_pxpy(sqrt(px*px+py*py)), m_pxpypz(sqrt(px*px+py*py+pz*pz)){;}
  ~COmega(){;}

  void Phi(double& px, double& py)
  {
    double pxtemp(px), pytemp(py);

    px = (m_px*pxtemp-m_py*pytemp)/m_pxpy;
    py = (m_py*pxtemp+m_px*pytemp)/m_pxpy;
  }
  void PhiBar(double& px, double& py)
  {
    double pxtemp(px), pytemp(py);

    px = (m_px*pxtemp+m_py*pytemp)/m_pxpy;
    py = (-m_py*pxtemp+m_px*pytemp)/m_pxpy;
  }
  void Theta(double& px, double& py, double& pz)
  {
    double pxtemp(px), pytemp(py), pztemp(pz);
    double pxpytemp = sqrt(pxtemp*pxtemp+pytemp*pytemp);
    double pxpy = (m_pxpy*pztemp+m_pz*pxpytemp)/m_pxpypz;

    pz = (m_pz*pztemp-m_pxpy*pxpytemp)/m_pxpypz;
    if(pxpytemp != 0){
      px = pxpy*pxtemp/pxpytemp;
      py = pxpy*pytemp/pxpytemp;
    }else{
      px = pxpy*m_px/m_pxpy;
      py = pxpy*m_py/m_pxpy;
    }
  }
  void ThetaBar(double& px, double& py, double& pz)
  {
    double pxtemp(px), pytemp(py), pztemp(pz);
    double pxpytemp = sqrt(pxtemp*pxtemp+pytemp*pytemp);
    double pxpy = (-m_pxpy*pztemp+m_pz*pxpytemp)/m_pxpypz;

    pz = (m_pz*pztemp+m_pxpy*pxpytemp)/m_pxpypz;
    if(pxpytemp != 0){
      px = pxpy*pxtemp/pxpytemp;
      py = pxpy*pytemp/pxpytemp;
    }else{
      px = pxpy*m_px/m_pxpy;
      py = pxpy*m_py/m_pxpy;
    }
  }

private:
  const double m_px, m_py, m_pz;
  const double m_pxpy, m_pxpypz;
};

int main()
{
  COmega o(1/sqrt(2),1/sqrt(2),1);
  double px = 1;
  double py = 1;
  double pz = 0;

  std::cout << px << " " << py << " " << pz << std::endl;
  o.ThetaBar(px, py, pz);
  std::cout << px << " " << py << " " << pz << std::endl;
  o.ThetaBar(px, py, pz);
  std::cout << px << " " << py << " " << pz << std::endl;  
  o.ThetaBar(px, py, pz);
  std::cout << px << " " << py << " " << pz << std::endl;  
  o.ThetaBar(px, py, pz);
  std::cout << px << " " << py << " " << pz << std::endl;  
  o.ThetaBar(px, py, pz);
  std::cout << px << " " << py << " " << pz << std::endl;  


  return 0;
}
