
#include <iostream>
#include <cmath>

//方向ベクトルがz軸に平行になるように回転・元に戻すクラス
class COmega
{
public:
  COmega(double px, double py, double pz)
    : m_px(px), m_py(py), m_pz(pz),
      m_pxpy(sqrt(px*px+py*py)), m_pxpypz(sqrt(px*px+py*py+pz*pz)){;}
  ~COmega(){;}

  //方向ベクトルをz軸に平行にする回転演算
  void Aline(double& px, double& py, double& pz)
  {
    PhiBar(px, py, pz);
    ThetaBar(px, py, pz);
    Phi(px, py, pz);
  }
  //z軸に平行にした方向ベクトル元に戻す回転演算
  void Skew(double& px, double& py, double& pz)
  {
    PhiBar(px, py, pz);
    Theta(px, py, pz);
    Phi(px, py, pz);
  }

private:
  void Phi(double& px, double& py, double& /*pz*/)
  {
    double pxtemp(px), pytemp(py);

    px = (m_px*pxtemp-m_py*pytemp)/m_pxpy;
    py = (m_py*pxtemp+m_px*pytemp)/m_pxpy;
  }
  void PhiBar(double& px, double& py, double& /*pz*/)
  {
    double pxtemp(px), pytemp(py);

    px = (m_px*pxtemp+m_py*pytemp)/m_pxpy;
    py = (-m_py*pxtemp+m_px*pytemp)/m_pxpy;
  }
  void Theta(double& px, double& py, double& pz)
  {
    double pztemp(pz), pxtemp(px);

    pz = (m_pz*pztemp-m_pxpy*pxtemp)/m_pxpypz;
    px = (m_pxpy*pztemp+m_pz*pxtemp)/m_pxpypz;
  }
  void ThetaBar(double& px, double& py, double& pz)
  {
    double pztemp(pz), pxtemp(px);

    pz = (m_pz*pztemp+m_pxpy*pxtemp)/m_pxpypz;
    px = (-m_pxpy*pztemp+m_pz*pxtemp)/m_pxpypz;
  }

private:
  const double m_px, m_py, m_pz;
  const double m_pxpy, m_pxpypz;
};

int main()
{
  COmega o(1/sqrt(2),1/sqrt(2),1);
  double px = 0;
  double py = 0;
  double pz = 1;

  std::cout << px << " " << py << " " << pz << std::endl;  
  o.Aline(px, py, pz);
  std::cout << px << " " << py << " " << pz << std::endl;  
  o.Skew(px, py, pz);
  std::cout << px << " " << py << " " << pz << std::endl;  

  return 0;
}
