
void example_graph(std::string dir = "", bool dot = true)
{
  clear();

  gStyle->SetOptFit(0);
  gStyle->SetOptTitle(0);

  TCanvas* canvas = new TCanvas("canvas", "", 1000, 700);
  canvas->SetFillColor(0);

  //  dir = "9Li/";
  //  dir = "135ps/";
  //  dir = "135ps9Li/";
  //  dir = "200ps/";
  //  dir = "nebula/";

  TGraph* g = new TGraph(std::string("data/" + dir + "erelkev.txt").c_str(), "%lf %lf", "");
  //  TGraph* g = new TGraph(std::string("data/" + dir + "erel2sou.txt").c_str(), "%lf %lf", "");
  //  TGraph* g = new TGraph(std::string("data/" + dir + "EnergyResolution.txt").c_str(), "%lf %*lf %*lf %lf %*lf", "");

  g->SetTitle(";Relative Energy[keV];Energy Resolution(FWHM)[keV]");
  g->SetMarkerStyle(8);
  g->Draw("ap");

  //  TF1* f = new TF1("f", "sqrt(x*[0])+[1]", 0, 3.6);
  TF1* f = new TF1("f", "sqrt(x*[0])+[1]", 0, 1600);
  f->SetParameters(7.5, 3.2e-1);
  g->Fit(f);

  g->SetMaximum(140);
  g->GetXaxis()->SetRangeUser(0., 1700.);
  //  g->GetXaxis()->SetRange(0., 1600.);
  if(dot){
    g->SetMarkerStyle(20);
    g->SetMarkerColor(0);
  }
}
