#include "CDataHimeSim.hh"
#include "CKinema.hh"
#include "CParticle.hh"
#include "CParticleDefinition.hh"

#include <iostream>
#include <fstream>
#include <cmath>

void energy_range()
{
  static const double width(2.*2);//thrとの兼ね合いから2層分ぐらいの距離が3層での検出の境界になる。
  static const double step(300.);

  CParticle nin = CParticleDefinition::GetParticle("neutron");
  CParticle pin = CParticleDefinition::GetParticle("proton");
  CParticle nout = CParticleDefinition::GetParticle("neutron");
  CParticle pout = CParticleDefinition::GetParticle("proton");

  nin.p(0,0,1);//direction
  nin.k(70);
  //  nin.k(100);
  //  nin.k(250);
  pin.k(0);

  std::ofstream ofs("temp.txt");

  for(double theta = 0; theta < 3.14159/2; theta += 0.01){
    double theta_cm = CKinema::Scatter(theta, 0, nin, pin, pout, nout);
    double range  = CKinema::BetheBloch::Range("p", "Scint", pout.k(), step);
    ofs << theta << " " << theta_cm << " " << pout.k() << " " << range << " " << width/cos(theta) << std::endl;
  }

  return;
}  
