{
  clear();

  gROOT->ProcessLine(".x macros/erel/Resolution.C++");

  //hist
  readhist("root/temp.root");

  gHist[0]->SetTitle("Erel=12.5keV;Erel[MeV];counts");
  gHist[1]->SetTitle("Erel=25keV  ;Erel[MeV];counts");
  gHist[2]->SetTitle("Erel=50keV  ;Erel[MeV];counts");
  gHist[3]->SetTitle("Erel=100keV ;Erel[MeV];counts");
  gHist[4]->SetTitle("Erel=200keV ;Erel[MeV];counts");
  gHist[5]->SetTitle("Erel=400keV ;Erel[MeV];counts");
  gHist[6]->SetTitle("Erel=800keV ;Erel[MeV];counts");
  gHist[7]->SetTitle("Erel=1600keV;Erel[MeV];counts");

  zone(2,4);

  std::ofstream ofs(std::string("txt/EnergyResolution.txt").c_str());

   double coef = 1000*2.35482;
  
  ht(0);
  TFitResultPtr frp = fitg("S");
  //  ofs << "0.0125 " << frp->Parameter(1) << " " << frp->ParError(1) << " " << coef*frp->Parameter(2) << " " << coef*frp->ParError(2) << std::endl;
  hn();
  TFitResultPtr frp = fitg("S");
  //  ofs << "0.025 " << frp->Parameter(1) << " " << frp->ParError(1) << " " << coef*frp->Parameter(2) << " " << coef*frp->ParError(2) << std::endl;
  hn();
  TFitResultPtr frp = fitg("S");
  ofs << "0.050 " << frp->Parameter(1) << " " << frp->ParError(1) << " " << coef*frp->Parameter(2) << " " << coef*frp->ParError(2) << std::endl;
  hn();
  TFitResultPtr frp = fitg("S");
  ofs << "0.100 " << frp->Parameter(1) << " " << frp->ParError(1) << " " << coef*frp->Parameter(2) << " " << coef*frp->ParError(2) << std::endl;
  hn();
  TFitResultPtr frp = fitg("S");
  ofs << "0.200 " << frp->Parameter(1) << " " << frp->ParError(1) << " " << coef*frp->Parameter(2) << " " << coef*frp->ParError(2) << std::endl;
  hn();
  TFitResultPtr frp = fitg("S");
  ofs << "0.400 " << frp->Parameter(1) << " " << frp->ParError(1) << " " << coef*frp->Parameter(2) << " " << coef*frp->ParError(2) << std::endl;
  hn();
  TFitResultPtr frp = fitg("S");
  ofs << "0.800 " << frp->Parameter(1) << " " << frp->ParError(1) << " " << coef*frp->Parameter(2) << " " << coef*frp->ParError(2) << std::endl;
  hn();
  TFitResultPtr frp = fitg("S");
  ofs << "1.600 " << frp->Parameter(1) << " " << frp->ParError(1) << " " << coef*frp->Parameter(2) << " " << coef*frp->ParError(2) << std::endl;

  // graph
  gStyle->SetOptFit(0);
  gStyle->SetOptTitle(0);

  zone();

  TGraph* g = new TGraph(std::string("txt/EnergyResolution.txt").c_str(), "%lf %*lf %*lf %lf %*lf", "");

  g->SetMinimum(0);
  //  g->SetMaximum(140);
  g->GetXaxis()->SetLimits(0., 1.7);

  gStyle->SetLabelSize(0.06,"XYZ");
  gStyle->SetTitleSize(0.06,"XYZ");
  g->SetTitle(";Relative Energy[MeV];Energy Resolution(FWHM)[keV]");
  g->SetMarkerStyle(8);
  g->Draw("ap");

  //  TF1* f = new TF1("f", "sqrt(x*[0])+[1]", 0, 1.6);
  TF1* f = new TF1("f", "sqrt(x*[0])+[1]", 0.0, 1.6);
  f->SetParameters(1.0e+4,1.0);
  f->FixParameter(1,0.0);
  g->Fit(f);

  std::cout << f->Eval(1.) << std::endl;

  //  if(dot){
  //  g->SetMarkerStyle(20);
  //  g->SetMarkerColor(0);
  //  }
}
