
#include "TRandom3.h"
#include "TH1D.h"
#include "TFitResult.h"
#include "TFitResultPtr.h"

#include <iostream>
#include <fstream>

int PhotonAttenuation(int InitialPhotonNumber, double length,
		      double attenuation, double steplength);

void gen()
{
  int InitialPhotonNumber = 10000;
  double length = 10;
  double attenuation = 10;
  double steplength = 0.01;
  TH1D* hist = new TH1D("hist", "title", 300, 0, 1);

  for(int j = 0; j < 100; ++j){
    int PhotonNumber = PhotonAttenuation(InitialPhotonNumber,
					length, attenuation, steplength);
    double rate = (double)PhotonNumber/InitialPhotonNumber;
    std::cout << rate << std::endl;
    hist->Fill(rate);
  }

  hist->Draw();
  TFitResultPtr frp = hist->Fit("gaus", "S");
  std::ofstream ofs(std::string("temp.txt").c_str());
  std::cout << InitialPhotonNumber << " "
    //  ofs << InitialPhotonNumber << " "
      << frp->Parameter(1) << " "
      << frp->ParError(1) << " "
      << frp->Parameter(2) << " "
      << frp->ParError(2) << std::endl;

  double k = -length/log(frp->Parameter(1));
  std::cout << k*frp->Parameter(2)/frp->Parameter(1) << std::endl;
}

int PhotonAttenuation(int InitialPhotonNumber, double length,
	   double attenuation, double steplength)
{
  static TRandom3 random; 
  double probability = 1/attenuation*steplength;

  int PhotonNumber = InitialPhotonNumber;
  double position = 0;
  while(position < length){
    int PhotonNumberTemp = 0;
    for(int i = 0; i < PhotonNumber; ++i){
      if(random.Rndm() > probability) ++PhotonNumberTemp;
    }
    PhotonNumber = PhotonNumberTemp;
    position +=steplength;
  }

  return PhotonNumber;
}
