
#include "TRandom3.h"
#include "TH1D.h"
#include "TFitResult.h"
#include "TFitResultPtr.h"

#include <iostream>
#include <string>
#include <fstream>
#include <sstream>

int PhotonAttenuation(int InitialPhotonNumber, double length,
		      double attenuation, double steplength);

void gen2()
{
  std::ofstream ofs(std::string("temp.txt").c_str());

  int InitialPhotonNumber = 100000;
  double length = 10;
  double attenuation = 100;
  double steplength = 0.01;
  
  int count = 0;
  while(InitialPhotonNumber >= 100){
    std::stringstream iss;
    iss << "hist" << ++count;

    TH1D* hist = new TH1D(iss.str().c_str(), "title", 300, 0, 1);

    for(int j = 0; j < 500000/InitialPhotonNumber; ++j){
      //    for(int j = 0; j < 100; ++j){
      int PhotonNumber = PhotonAttenuation(InitialPhotonNumber,
					   length, attenuation, steplength);
      double rate = (double)PhotonNumber/InitialPhotonNumber;
      //      std::cout << rate << std::endl;
      hist->Fill(rate);
    }

    hist->Draw();
    TFitResultPtr frp = hist->Fit("gaus", "S");
    //    std::cout << InitialPhotonNumber << " "
    ofs << InitialPhotonNumber << " "
	      << frp->Parameter(1) << " "
	      << frp->ParError(1) << " "
	      << frp->Parameter(2) << " "
	      << frp->ParError(2) << std::endl;

    double k = -length/log(frp->Parameter(1));
    std::cout << k*frp->Parameter(2)/exp(-length/attenuation) << std::endl;

    InitialPhotonNumber /= 10;
  }
}

int PhotonAttenuation(int InitialPhotonNumber, double length,
	   double attenuation, double steplength)
{
  static TRandom3 random; 
  double probability = 1/attenuation*steplength;

  int PhotonNumber = InitialPhotonNumber;
  double position = 0;
  while(position < length){
    int PhotonNumberTemp = 0;
    for(int i = 0; i < PhotonNumber; ++i){
      if(random.Rndm() > probability) ++PhotonNumberTemp;
    }
    PhotonNumber = PhotonNumberTemp;
    position +=steplength;
  }

  return PhotonNumber;
}
