#ifndef FREADFILE_HH
#define FREADFILE_HH

#include <string>
#include <vector>

class FReadFile
{
public:
  //fileからデータの配列を読み込んでvectorに格納する。
  static int ReadIn(std::string filename, std::vector<std::vector<double> >& xy);
  //読み込んだvectorを降順で行列の形にvectorに格納する。
  //読み込んだvector, 新しいvector(行列), xindex, yindex, findex
  static int ReFill(std::vector<std::vector<double> > xy, 
	     std::vector<std::vector<double> >& xy_new, 
	     int xindex, int yindex, int findex);
  //vector<vector<double> > を一気にprintする
  static void Print(const std::vector<std::vector<double> >& xy);

private:
  //ソートのためのプレディケート
  class FLessX
  {
  public:
    static void SetIndex(int index){m_index = index;}
    bool operator()(const std::vector<double>& riLeft,
		    const std::vector<double>& riRight) const
    {
      return riLeft[0] < riRight[0];
    }

  private:
    static int m_index;
  };

  //ソートのためのプレディケート
  class FLessY
  {
  public:
    static void SetIndex(int index){m_index = index;}
    bool operator()(const std::vector<double>& riLeft,
		    const std::vector<double>& riRight) const
    {
      return riLeft[1] < riRight[1];
    }

  private:
    static int m_index;
  };
};

#endif
