#ifndef CFILEMANAGER_HH
#define CFILEMANAGER_HH

#include <string>
#include <vector>

#include "IArrayManager.hh"

class TFile;
class TChain;
class CInitializer;
class CBranchManager;
class CHistManager;
class TTreeManager;

namespace NAlias
{
  extern CInitializer* initializer;
  extern CBranchManager* branchmanager;
  extern CHistManager* histmanager;
  extern CTreeManager* treemanager;
}

class CFileManager : public IArrayManager
{
public:
  CFileManager() : IArrayManager()
  {
    IArrayManager::listname = "filemanager";
  }
  ~CFileManager(){;}

  void ReadTree(std::string filename, std::string treename = "", std::string chainname = "");
  void WriteTree(std::string filename, std::string option = "NEW");
  void ReadHist(std::string filename, int offset = -1);
  void WriteHist(std::string filename, std::string option = "NEW");
  void TxtToTree(std::string filename, std::string branchname, std::string treename = "temptree", std::string treetitle = "title");
  void VectorToTree(std::vector<std::vector<int> >& eventbuffer, std::string branchname, std::string treename = "temptree", std::string treetitle = "title");
  TFile* GetFile(std::string filename);
  TFile* GetFile(int id);
  TFile* GetFile();
  void Draw(int);

private:
  std::string FunctionName(std::string functionname) const;
};



#endif
