#ifndef CTREEMANAGER_HH
#define CTREEMANAGER_HH

#include "TChain.h"

#include <string>

#include "IArrayManager.hh"

class TTree;
class CBranchManager;

namespace NAlias
{
  extern CBranchManager* branchmanager;
}

class CTreeManager : public IArrayManager
{
public:
  CTreeManager() : IArrayManager()
  {
    IArrayManager::listname = "treemanager";
  }
  ~CTreeManager(){;}

  TTree* GetTree(std::string name);
  TTree* GetTree(int id);
  TTree* GetTree();
  TTree* GetTreeTop();
  void Push(std::string name, std::string title);
  void Draw(int);
  void Write();

  void BeFriends();
  void TreeToBranch();

private:
  std::string FunctionName(std::string functionname) const;
};

#endif
