#ifndef ICALCULATOR_HH
#define ICALCULATOR_HH

#include "TTree.h"

#include <string>

class CInitializer;
class CBranchManager;

namespace NAlias
{
  extern CInitializer* initializer;
  extern CBranchManager* branchmanager;
}

class ICalculator
{
public:
  ICalculator(){;}
  virtual ~ICalculator(){;}

  virtual void Calculate(std::string treename = "newtree", std::string treetitle = "title");

protected:
  virtual bool Begin() = 0;
  virtual bool Loop();
  virtual bool InnerLoop() = 0;
  virtual bool End() = 0;

  virtual void ErrorMessage(std::string s);

protected:
  TTree* oldtree;
  TTree* newtree;
  Long64_t nentries;
};

#endif
