#ifndef CDYNAMICFUNCTION_HH
#define CDYNAMICFUNCTION_HH

#include "TPad.h"
#include "TCanvas.h"
#include "Buttons.h"

#include "CCanvasManager.hh"

namespace NAlias
{
  extern CCanvasManager* canvasmanager;
}

class CDynamicFunction
{
public:
  CDynamicFunction(){;}
  ~CDynamicFunction(){;}  

  void SelectPad();
  class FSelectPad
  {
  public:
    bool operator()(Int_t event, TPad* pad);
  };

  void XValue(double& x);
  void XValue();
  class FXValue
  {
    friend class CDynamicFunction;

  public:
    bool operator()(Int_t event, TPad* pad);

  private:
    static double xval;
  };

  void YValue(double& y);
  void YValue();
  class FYValue
  {
    friend class CDynamicFunction;

  public:
    bool operator()(Int_t event, TPad* pad);

  private:
    static double yval;
  };

  void XYValue(double& x, double& y);
  void XYValue();
  class FXYValue
  {
    friend class CDynamicFunction;

  public:
    bool operator()(Int_t event, TPad* pad);

  private:
    static double xval;
    static double yval;
  };

  void Circle(double& x, double& y, double& r1, double& r2);
  void Circle();
  class FCircle
  {
    friend class CDynamicFunction;

  public:
    bool operator()(Int_t event, TPad* pad);

  private:
    static double xval;
    static double yval;
    static double r1val;
    static double r2val;
  };

  void WheelZoom();
  class FWheelZoom
  {
  public:
    FWheelZoom();
    ~FWheelZoom();

    bool operator()(Int_t event, TPad* pad);

  private:
    UInt_t step;
    UInt_t stepww,stepwh;    
    UInt_t ww,wh;
  };

public:
  static std::string space;
  static std::string GetSpace()
  {
    std::string s;
    for(int i=0; i<70; ++i) s += ' ';
    return s;
  }
};

#endif
