//included by CDynamicFunction.cc

void CDynamicFunction::WheelZoom()
{
  SelectPad();
  std::cout << "[CDynamicFunction::CWheelZoom]$ zoom:mouse wheel up or down, quit:press any key" << std::endl;
  CEventLoop eventloop;
  eventloop.EventLoop(CDynamicFunction::FWheelZoom());
}

CDynamicFunction::FWheelZoom::FWheelZoom()
{
  //  TPad* pad((TPad*)gROOT->GetSelectedPad());
  TCanvas* canvas = NAlias::canvasmanager->GetCanvas();
  ww = canvas->GetWw();
  wh = canvas->GetWh();
  step = 50;
  stepww = step*ww/(ww+wh);
  stepwh = step*wh/(ww+wh);
}

CDynamicFunction::FWheelZoom::~FWheelZoom(){;}

bool CDynamicFunction::FWheelZoom::operator()(Int_t event, TPad*/*pad*/)
{
  if(event == kKeyPress){
    return true;
  }

  TCanvas* canvas = NAlias::canvasmanager->GetCanvas();

  if(event == kWheelUp){
    canvas->SetCanvasSize(ww += stepww, wh += stepwh);
  }else if(event == kWheelDown){
    if((ww - stepww) > 100 && ((wh - stepwh) > 100)){
      canvas->SetCanvasSize(ww -= stepww, wh -= stepwh);
    }
  }

  canvas->HandleInput(kNoEvent, canvas->GetEventX(), canvas->GetEventY());
  return false;
}

