//included by CDynamicFunction.cc

double CDynamicFunction::FYValue::yval(0);

void CDynamicFunction::YValue(double& y)
{
  SelectPad();
  CEventLoop eventloop;
  eventloop.EventLoop(CDynamicFunction::FYValue());
  y = FYValue::yval;
}

void CDynamicFunction::YValue()
{
  std::cout << "[CDynamicFunction::YValue]$ press any key to quit" << std::endl;
  double y;
  YValue(y);
}

bool CDynamicFunction::FYValue::operator()(Int_t event, TPad* pad)
{
  static TLine* l(0);

  if(event == kKeyPress){
    std::cout << std::endl;
    l = 0;
    return true;
  }

  Int_t py = pad->GetEventY();
  Double_t y = pad->AbsPixeltoY(py); 
  yval = y;
  double x1 = pad->GetX1();
  double x2 = pad->GetX2();

  if(!l){
    l = new TLine(x1, y, x2, y);
  }

  l->SetY1(y);
  l->SetY2(y);
  l->Draw();

  std::cout.setf(std::ios::scientific);
  std::cout << "\r" << space
	    << "\r  y:" << std::setprecision(2) << y;
  std::cout << std::flush;
  std::cout.unsetf(std::ios::scientific);

  return false;
}
