#ifndef CMAPFUNCTION1D2_HH
#define CMAPFUNCTION1D2_HH

#include <deque>
#include <string>

#include "TF1.h"

class CMapFunction1D2
{
public:
  CMapFunction1D2();
  ~CMapFunction1D2();

  void SetFile(std::string filename);
  TF1* GetMapFunction();

private:
  Double_t MapFunction(Double_t xx);
  Double_t MapFunction(Double_t* x, Double_t* /*par*/);
  void SetMap(const std::deque<Double_t>* f,
	      const std::deque<Double_t>* x);

  TF1* fMapFunction;
  std::deque<Double_t> fF, fX;

  ClassDef(CMapFunction1D2, 0)
};

#endif
