
#include "FReadFile.hh"

#include <iostream>
#include <iterator>
#include <fstream>
#include <sstream>
#include <algorithm>

ClassImp(FReadFile)

int FReadFile::FLessX::m_index(0);
int FReadFile::FLessY::m_index(1);

int FReadFile::ReadIn(std::string filename, CMapFunction::type_map2d& xy)
{
  std::ifstream ifs(filename.c_str());
  if(!ifs.is_open()){
    std::cout << filename << " dose not exist" << std::endl;
    return 0;
  }

  while(1){
    std::string str;
    std::getline(ifs, str);
    if(ifs.eof()) break;
    if(str.find("#") != std::string::npos) continue;
    std::istringstream iss(str);

    CMapFunction::type_map1d x;
    double xtemp;
    while(iss >> xtemp) x.push_back(xtemp);
    xy.push_back(x);
  }

  return 1;
}

int FReadFile::ReFill(CMapFunction::type_map2d xy, 
		      CMapFunction::type_map2d& xy_new, 
		      int xindex, int yindex, int findex)
{
  FLessX::SetIndex(xindex);
  std::sort(xy.begin(), xy.end(), FLessX());

  FLessY::SetIndex(yindex);
  std::stable_sort(xy.begin(), xy.end(), FLessY());

  CMapFunction::type_map2d::iterator it = xy.begin();
  while(it != xy.end()){
    CMapFunction::type_map1d x_new;
    double y = (*it)[yindex];
    while(it != xy.end() && y == (*it)[yindex]){
      x_new.push_back((*it)[findex]);
      ++it;
    }
    xy_new.push_back(x_new);
  }

#ifndef NDEBUG
  Check(xy_new);
#endif

  return 1;
}

int FReadFile::ReFillQuad(CMapFunction::type_map2d xy, 
			  CMapFunction::type_map2d& xy_new4, 
			  int xindex, int yindex, int findex)
{
  FLessX::SetIndex(xindex);
  std::sort(xy.begin(), xy.end(), FLessX());

  FLessY::SetIndex(yindex);
  std::stable_sort(xy.begin(), xy.end(), FLessY());

  CMapFunction::type_map2d xy_new2; 
  CMapFunction::type_map2d::iterator it = xy.begin();
  while(it != xy.end()){
    CMapFunction::type_map1d x_new;
    CMapFunction::type_map1d x_new2;
    double y = (*it)[yindex];
    while(it != xy.end() && y == (*it)[yindex]){
      x_new.push_back((*it)[findex]);
      ++it;
    }

    CMapFunction::type_map1d::reverse_iterator rit_inner = x_new.rbegin();
    while(rit_inner != x_new.rend()){
      x_new2.push_back(*rit_inner);
      ++rit_inner;
    }
    CMapFunction::type_map1d::iterator it_inner = x_new.begin();
    ++it_inner;
#ifndef NDEBUG
    if(it_inner == x_new.end()) std::abort();
#endif
    while(it_inner != x_new.end()){
      x_new2.push_back(*it_inner);
      ++it_inner;
    }      
    xy_new2.push_back(x_new2);
  }

  CMapFunction::type_map2d::reverse_iterator rit_new = xy_new2.rbegin();
  while(rit_new != xy_new2.rend()){
    xy_new4.push_back(*rit_new);
    ++rit_new;
  }
  CMapFunction::type_map2d::iterator it_new = xy_new2.begin();
  ++it_new;
#ifndef NDEBUG
  if(it_new == xy_new2.end()) std::abort();
#endif
  while(it_new != xy_new2.end()){
    xy_new4.push_back(*it_new);
    ++it_new;
  }      

#ifndef NDEBUG
  Check(xy_new4);
#endif

  return 1;
}

void FReadFile::Check(const CMapFunction::type_map2d& xy)
{
  CMapFunction::type_map2d::const_iterator it_new = xy.begin();
  if(it_new == xy.end()) std::abort();
  while(1){
    CMapFunction::type_map1d::size_type a = it_new->size();
    ++it_new; if(it_new == xy.end()) break;
    CMapFunction::type_map1d::size_type b = it_new->size();
    if(a != b){
      std::cout << "size of one line changed!! map must be rectangle"
		<< std::endl;
      std::abort();
    }
  }
}

void FReadFile::Print(const CMapFunction::type_map2d& xy)
{
  CMapFunction::type_map2d::const_iterator it = xy.begin();
  while(it != xy.end()){
    std::copy(it->begin(), it->end(),
	      std::ostream_iterator<double>(std::cout, " "));
    std::cout << std::endl;
    ++it;
  }
}
