#ifndef CMAGNET_HH
#define CMAGNET_HH

#include "TROOT.h"

#include "CMapFunction2D.hh"

#include <vector>

class CMagnet
{
public:
  CMagnet();
  ~CMagnet();

public:
  //map2d : Map of magnetic field[T]
  //vx,vy : Container of track. Input initial position to back of vx and vy
  //theta : Initial direction(x=cos(theta), y=sin(theta))[rad]
  //rstep : maximum range of one step[m]
  //thetastep : maximum angle of one step[rad]
  //rangelimit : limit of flight lengh[m]
  //mass : mass[MeV]
  //beta : v/c
  //q : charge of atom[e]
  static int CalTrack(CMapFunction2D* map2d,
		      std::vector<double>& vx, std::vector<double>& vy,
		      double theta,
		      double rstep, double thetastep, double rangelimit,
		      double mass, double beta, double q);

  ClassDef(CMagnet, 0)
};

#endif
