
#include "TF1.h"
#include "CParticle.hh"
#include "CParticleDefinition.hh"

Double_t de(Double_t *x, Double_t */*par*/);

void tof_de()
{
  TF1* f = new TF1("de", de, 50, 300, 0);

  f->SetMinimum(0);
  f->SetTitle(";ein(MeV);distance(m)");
  f->Draw();
}

Double_t de(Double_t *x, Double_t */*par*/)
{
  CParticle neutron = CParticleDefinition::GetParticle("neutron");

  Double_t kin = x[0];
  double dt = 0.7;
  double de = 2;
  neutron.k(kin);
  double gamma = neutron.gamma();

  double t = gamma*(1+gamma)*dt/de*kin;

  Double_t f = t*(neutron.beta()*29.979/100);

  return f;
}
