
#include "TF1.h"
#include "CParticle.hh"
#include "CParticleDefinition.hh"

Double_t dx(Double_t *x, Double_t */*par*/);

void tof_dx()
{
  TF1* f = new TF1("dx", dx, 50, 300, 0);

  f->SetMinimum(0);
  f->SetTitle(";ein(MeV);dt(ns)");
  f->Draw();
}

Double_t dx(Double_t *x, Double_t */*par*/)
{
  CParticle neutron = CParticleDefinition::GetParticle("neutron");

  Double_t kin = x[0];
  neutron.k(kin);
  Double_t f = 2/neutron.beta()/29.979/sqrt(12);

  return f;
}
